module Gen (string, reset) where
-- unsafe symbol generator

import Data.IORef
import System.IO.Unsafe

count :: IORef Int
count = unsafePerformIO (newIORef 0)

genInt :: IO Int
genInt = do { i <- readIORef count; writeIORef count (i+1); return i }

string :: String -> String
string stub =
  stub ++ show (unsafePerformIO genInt)

reset :: IO ()
reset = writeIORef count 0
